package com.example.flappybird;

import android.content.Context;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import java.util.Random;

public class Pipe {
    ImageView topPipe;
    ImageView bottomPipe;
    float pipeX;
    float pipeY;
    float GAP_SIZE;
    float PIPE_WIDTH;
    float PIPE_HEIGHT;
    boolean isScored = false;

    // Constructor
    public Pipe(Context context, float screenHeight, float screenWidth) {

        if (context instanceof MainActivity) {
            MainActivity activity = (MainActivity) context;

            // Calculate sizes based on screen dimensions
            GAP_SIZE = screenHeight / 4f;
            PIPE_WIDTH = screenWidth / 6f;
            PIPE_HEIGHT = screenHeight / 1.25f;

            // Create Pipes images
            topPipe = new ImageView(context);
            bottomPipe = new ImageView(context);
            topPipe.setImageResource(R.drawable.toppipe);
            bottomPipe.setImageResource(R.drawable.bottompipe);

            // Pipe characteristics
            pipeX = screenHeight;
            Random rand = new Random(); // Random Height generator for Top
            //pipeY = (rand.nextFloat() * screenHeight) - 900f;
            pipeY = -(PIPE_HEIGHT / 4) - rand.nextFloat() * (PIPE_HEIGHT / 2);

            // Draw Pipes
            topPipe.setLayoutParams(new ViewGroup.LayoutParams((int) PIPE_WIDTH, (int) PIPE_HEIGHT));
            bottomPipe.setLayoutParams(new ViewGroup.LayoutParams((int) PIPE_WIDTH, (int) PIPE_HEIGHT));

            // Set Pipes position
            topPipe.setX(pipeX);
            bottomPipe.setX(pipeX);
            topPipe.setY(pipeY);
            bottomPipe.setY(pipeY + PIPE_HEIGHT + GAP_SIZE);

            // Add pipes to layout
            ((ViewGroup) activity.findViewById(R.id.main)).addView(topPipe);
            ((ViewGroup) activity.findViewById(R.id.main)).addView(bottomPipe);
        }
    }

    public void move() {
        pipeX -= 5; // Move pipe to the left
        topPipe.setX(pipeX);
        bottomPipe.setX(pipeX);
    }


    public void remove() {
        topPipe.setVisibility(View.GONE);
        bottomPipe.setVisibility(View.GONE);
    }
}
